module PCUnit(
    input clk,                  // тактовый сигнал
    input reset,                // сигнал сброса
    input branchTaken,          // сигнал ветвления
    input [31:0] branchAddr,    // адрес для перехода при ветвлении
    output reg [31:0] pc        // выход счетчика
);
    

    // Инициализация PC стартовым адресом
    initial pc = 32'b0;

    // анализ сигнала clk по фронту
    always @(posedge clk) begin
        if (reset) begin
            // Установка PC в начальный адрес при сбросе
            pc <= 32'b0;
        end else if (branchTaken) begin
            // Если присутсвует сигнал перехода то счетчик указывает на адрес branchAddr
            pc <= branchAddr;
        end else begin
            // иначе PC увеличивается на 4
            pc <= pc + 4;
        end
    end
endmodule